<template>
    <div class="sw-gs-client-name-modal" v-if="!hasSavedSettings && !callIsSetup && !isPreview">
        <template v-if="!deviceError">
            <SfModal class="sw-modal" :title="videoChatEnabled ? $t('Video Settings') : $t('Sound Settings')" :visible="isModalOpen" persistent :cross="false">
                <transition name="fade" mode="out-in">
                    <div class="sw-gs-video-modal__wrapper">
                        <div class="sw-gs--video-modal-title">
                            <h4>{{ videoChatEnabled ? $t('Video Settings') : $t('Sound Settings') }}</h4>
                        </div>
                        <SwGsVideoSetup/>
                        <div class="sw-gs--video-modal-button-wrapper">
                            <SwButton class="sw-gs-save-video-settings-btn color-primary"
                                      :disabled="!isSetupReady"
                                      :title="$t('Save')"
                                      @click="onSave">
                                {{ $t('Save') }}
                            </SwButton>
                        </div>
                    </div>
                </transition>
            </SfModal>
        </template>
    </div>
</template>

<script>
import { onMounted } from "@vue/composition-api"
import { SfModal } from "@storefront-ui/vue"
import SwButton from "@/components/atoms/SwButton.vue";
import SwGsVideoSetup from "./SwGsVideoSetup";
import { useUIState } from "@shopware-pwa/composables"
import { useMediaDevices } from "../logic/composables/useMediaDevices";
import { useVideoSetup } from "../logic/composables/useVideoSetup";
import { useVideoCall } from "../logic/composables/useVideoCall";
import { useAppointment } from "../logic/composables/useAppointment";
import { useClearBodyScrollLock } from "../logic/composables/useClearBodyScrollLock";

export default {
    name: "SwGsVideoSettingsModal",
    components: {
        SfModal,
        SwGsVideoSetup,
        SwButton
    },

    setup() {
        const { saveDevicesToStorage, hasSavedSettings, deviceError } = useMediaDevices();
        const { isSetupReady } = useVideoSetup();
        const { callIsSetup, videoChatEnabled } = useVideoCall();
        const { isPreview } = useAppointment();
        const { isOpen, switchState } = useUIState({ stateName: "GS_VIDEO_MODAL_STATE" });

        onMounted(() => {
            if (!hasSavedSettings.value) switchState(true);
        });

        useClearBodyScrollLock();

        const onSave = () => {
            switchState(false);
            saveDevicesToStorage();
        };

        return {
            onSave,
            deviceError,
            hasSavedSettings,
            isSetupReady,
            isModalOpen: isOpen,
            callIsSetup,
            videoChatEnabled,
            isPreview
        }
    },
}
</script>

<style lang="scss" scoped>
@import "@/assets/scss/variables";

.sw-gs-device-error-modal-error {
    display: flex;
    flex-direction: column;

    .sw-gs-device-error-modal-error-headline {
        font-weight: bold;
    }

    .sw-gs-device-error-modal-error-content {

        ol {
            text-align: left;
            padding-left: 20px;
        }
    }
}

.sw-gs-client-name-modal {
    ::v-deep {
        .sf-modal__overlay {
            z-index: var(--top-modal-overlay-z-index);
        }

        .sf-modal__container {
            z-index: var(--top-modal-container-z-index);

            @include for-tablet {
                min-width: 660px;
            }
        }
    }
}

.sw-gs-video-modal__wrapper,
.sw-gs--video-modal-title {
    text-align: center;
}

.sw-gs--video-modal-button-wrapper {
    padding-top: 20px;
    text-align: right;

    &.audio-only {
        text-align: center;
        display: flex;
        justify-content: space-between;
    }

    .sw-gs-save-video-settings-btn {
        display: inline-block;
    }
}

</style>
